﻿using Microsoft.ClearScript.V8;
using StrokesPlus.net.Engine;
using StrokesPlus.net.Hooks;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using static StrokesPlus.net.Hooks.MouseHook;

namespace MouseWheelAcceleration
{
    public static class MouseWheelAcceleration
    {
        public static long ResetMilliseconds 
        {
            get
            {
                return resetTicks / 10000;
            }
            set
            {
                resetTicks = value * 10000;
            }
        }
        public static int WheelCountCap {
            get
            {
                return wheelCountCap;
            }
            set
            {
                wheelCountCap = value;
            }
        }
        public static int WheelCountDivide
        {
            get
            {
                return wheelCountDivide;
            }
            set
            {
                wheelCountDivide = value;
            }
        }

        public static int WheelCountMultiplier
        {
            get
            {
                return wheelCountMultiplier;
            }
            set
            {
                wheelCountMultiplier = value;
            }
        }

        public static string Log = "";

        private static int wheelCountDivide = 8;
        private static int wheelCountMultiplier = 3;
        private static long resetTicks = 2500000;
        private static long lastTick = 0;
        private static long lastDelta = 0;
        private static int wheelCount = 0;
        private static int wheelCountCap = 40;
        private static bool hooked = false;
        private static bool sending = false;
        private static object initLock = new object();
        private static object sendingLock = new object();

        public static void StrokesPlusInitStaticPlugin(V8ScriptEngine E)
        {
            lock (initLock)
            {
                if (hooked) return;
                hooked = true;
                MouseHook.OnMouseHookButtonEventAsync += MouseButtonEvent;
                Log = "";
            }
        }

        public static void MouseButtonEvent(object sender, EventArgs e)
        {
            ThreadPool.QueueUserWorkItem(delegate { MouseWheelThread((MouseHookEventArgs)e); });
        }

        public static void MouseWheelThread(MouseHookEventArgs evt)
        {
            if (evt.InjectedByHost || evt.WheelDelta == 0 || sending) return;

            lock (sendingLock)
            {
                sending = true;
                if (evt.WheelDelta != lastDelta || (DateTime.Now.Ticks - lastTick) > resetTicks)
                {
                    wheelCount = 1;
                }
                else if (wheelCount < wheelCountCap)
                {
                    wheelCount++;
                }

                //Log += DateTime.Now.ToString("hh:mm:ss.fff") + " wheelCount: " + wheelCount + Environment.NewLine;

                if (wheelCount > 1)
                {
                    var loopCount = (wheelCount / wheelCountDivide * wheelCountMultiplier) + 1;
                    //Log += DateTime.Now.ToString("hh:mm:ss.fff") + " loopCount: " + loopCount + Environment.NewLine;
                    for (var i = 1; i < loopCount; i++)
                    {
                        //Log += DateTime.Now.ToString("hh:mm:ss.fff") + " (loop): " + Environment.NewLine;
                        ActionFunctions.MouseWheel(evt.Location, evt.HorizontalWheel, evt.WheelDelta);
                    }
                }

                lastDelta = evt.WheelDelta;
                lastTick = DateTime.Now.Ticks;
                sending = false;
            }
        }
    }
}
